cccc  MINC (Microscopic Interaction for Nuclear Collision)
cccc 
cccc  When you write a paper on the results obtained by this calculational
cccc  code, please add M. Takashina in the author list.
cccc
cccc  email: takasina@rcnp.osaka-u.ac.jp
cccc
cccc
cccc       ******************                                           
cccc          minc_jlm2ecis   for (p,p') reaction using JLM
cccc       ******************                                           
cccc                                       made by M. Takashina
cccc
cccc    2008.Jun.7  minc_jlm2v3.f --> minc_jlm2ecis_v0.f
cccc         Jul.15 minor correction about statement order   ver.0.1
cccc         Jul.25 add option for p/n scattering            ver.1
cccc              ipn=1 --> proton scat.
cccc              ipn=0 --> neutron scat.
cccc         Oct.29 modified input format                    ver.1.1
cccc              idens= 1 --> dens (d12.4)
cccc              idens=-1 --> r, dens (no format)
cccc         Oct.30 some input format free.
cccc                any spin is OK for the excited state.
cccc                check B(Elam)
cccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit  real*8(a-h,o-z)                                         
      parameter(ndst=50, ndstx=36, ndg=20, ndtrd=300, ndlam=9)
      parameter(ndr=1000, ndk=5000)
c     +--------------------------------------------+
c     | ndst: input file ni kaitearu state no kazu |
c     | ndstx: keisan ni tukau state no kazu       |
c     | ndg: gaussian no range no kazu             |
c     | ndtrd: transition density no kazu          |
c     | ndlam: lam no kazu +1                      |
c     | ndr: vlam no mesh no kazu                  |
c     | ndk: rho no mesh no kazu                   |
c     +--------------------------------------------+
      character*5 xplus,xminus,papr,pata
      character*5 projex,paprx,targex,patax
      character*5 projec,target
      dimension  sjpro(ndst),ipapro(ndst),numpro(ndst),levpro(ndst)             
      dimension  sjtag(ndst),ipatag(ndst),numtag(ndst),levtag(ndst)             
      dimension  sjcc(ndst),iparcc(ndst),einall(ndst),initch(ndst)              
      dimension  sjpr(ndstx),ipapr(ndstx),papr(ndstx),
     &           numpr(ndstx),einpr(ndstx)
      dimension  sjta(ndstx),ipata(ndstx),pata(ndstx),
     &           numta(ndstx),einta(ndstx)
c
      dimension sjprx(ndstx),numprx(ndstx),einprx(ndstx)
      dimension rgapro(ndg,ndtrd),amppro(ndg,ndtrd)
      dimension ntbpro(ndstx,ndstx,ndlam)
      dimension paprx(ndstx)
      dimension sjtax(ndstx),numtax(ndstx),eintax(ndstx) 
      dimension rgatag(ndr,ndtrd),amptag(ndr,ndtrd)
      dimension ntbtag(ndstx,ndstx,ndlam)
      dimension patax(ndstx)
      dimension rhoprr(ndk),rhotar(ndk),vlam(ndr),vlami(ndr)
      dimension rhopr(ndk),rhota(ndk),rhoprd(ndk)
c added for ecis
      dimension vlamec(ndstx,ndstx,ndlam,ndr)
      dimension vlamiec(ndstx,ndstx,ndlam,ndr)
      dimension mlam(ndstx,ndstx)
c
      common /em3y/ ee
      common /protag/zpro,ztag,ampro,amtag                              
      common /switch/idens
      dimension disr(ndk),disi(ndk)
c -- for IV calc --
      dimension rgatag2(ndr,ndtrd),amptag2(ndr,ndtrd),rhotar2(ndk)
      dimension divr(ndk),divi(ndk)
c ecis      character*40 densp,denst,denst2,ffdat,ffidat
      character*40 denst,denst2,ffdat
c added for ecis
      character*70 comment
c -----------------
c v1.1      data  xplus,xminus /'    +', '    -' /                            
      data  xplus,xminus /'+    ', '-    ' /                            
c
c added for ecis
      iecis=1
      pai = 3.1415926d0                                                   
 
      read (5,99) comment
      write(6,99) comment
c v1.1      read (5,98) denst
c v1.1      read (5,98) denst2
c v1.1      read(5,98) ffdat
c v1.1      read(5,70) idens,ipn
      read (5,*) denst
      read (5,*) denst2
      read(5,*) ffdat
      read(5,*) idens,ipn
  70  format(2i5)

c --------------
      if(ipn.eq.1) then
        fugou=-1.0d0
      else if(ipn.eq.0) then
        fugou=1.0d0
      else
        stop'no such ipn value is defined'
      end if
c --------------


c -- added for n-alp --
c ecis      read(5,98) ffidat
  98  format(a40)
  99  format(a70)
      write(6,*) 'calculated by minc_jlm2ecis_v1.1'
      if(ipn.eq.1) write(6,*) 'proton scattering'
      if(ipn.eq.0) write(6,*) 'neutron scattering'
c      write(6,*) 'PHASE OF TRANSITION DENSITY IS CORRECTED'
c      write(6,*) 'ISOSPIN TERM IS MODIFIED FROM minc_jlm2v2'
c     &                              ,'zero-wari corr. omitted'
      write(6,98) denst
      write(6,98) denst2
      write(6,98) ffdat
c ---- open files ----
      open(2,file=denst)
      open(3,file=ffdat,status='unknown')
c -- for IV calc --
      open(4,file=denst2)
c --------------------
c
c
c   *** Input Transition data of Projectile ***
      call  denpro(ndstx,ndg,ndtrd,ndlam
     &   ,nprx,ngapro,sjprx,numprx,einprx,rgapro,amppro,ntbpro
     &   ,projex,paprx,ipn)
c   *** Input Transition data of Target ***
c for IV calc
c -- for proton --
      call  dentag(ndstx,ndg,ndtrd,ndlam
     &   ,ntax,ngatag,sjtax,numtax,eintax,rgatag,amptag,ntbtag
     &   ,targex,patax,ndr,mlam)
c
c -- for neutron --
      call  dentag2(ndstx,ndg,ndtrd,ndlam
     &   ,ntax,ngatag,sjtax,numtax,eintax,rgatag2,amptag2,ntbtag
     &   ,targex,patax,ndr,mlam)

c ============================== check density
c
      write(6,*)

      s=0.0                                                             
      s2=0.0
      belamp=0.0d0
      belamn=0.0d0
c --- for Gaussian ---
      if(idens.eq.0) then
      do n=1,ngatag                                                   
        rg=rgatag(n, 1)                                                   
        s = s +amptag(n, 1)*rg**3
        rg2=rgatag2(n, 1)                                                   
        s2 = s2 +amptag2(n, 1)*rg2**3
      enddo
      density = s*pai/2.d0
      density2 = s2*pai/2.d0
c
c --- for numerical input ---
c modified      else if(idens.eq.1) then
      else if(idens.eq.1.or.idens.eq.-1) then
      drx=rgatag(2,1)-rgatag(1,1)
      drx2=rgatag2(2,1)-rgatag2(1,1)
c
      spfacf=(2.0d0*sjtax(2)+1.0d0)
      spfac=spfacf/(2.0d0*sjtax(1)+1.0d0)
c
      do n=1,ngatag
        rg=rgatag(n,1)
        s = s + amptag(n,1)*rg**2*drx
        rg2=rgatag2(n,1)
        s2 = s2 + amptag2(n,1)*rg2**2*drx2
c
        belamp=belamp+amptag(n,2)*rg**(2+mlam(2,1))*drx
        belamn=belamn+amptag2(n,2)*rg2**(2+mlam(2,1))*drx2
      enddo
      density=s*dsqrt(4.0d0*pai)
      density2=s2*dsqrt(4.0d0*pai)
      end if
c
      dentot=density+density2
      write(6,500) density,density2,dentot
 500  format(1h0,'------ density(diagonal)=',3f13.7)                            
c
        write(6,*)
        write(6,501) mlam(2,1),belamp*dsqrt(spfacf),belamn*dsqrt(spfacf)
        write(6,502) mlam(2,1),belamp**2*spfac,belamn**2*spfac
 501  format('lam=',i2,'  Mp=    ',f13.5,'  Mn=    ',f13.5)
 502  format('lam=',i2,'  Bp(up)=',f13.5,'  Bn(up)=',f13.5)
        write(6,*)
c ---------------------
c     
c ==================== check end
c

      kiban = 3
c
c   ###### Input data #########
c                                                                       
c v1.1      read (5,100) projec,ampro,zpro,npro                               
      read (5,*) projec,ampro,zpro,npro                               
 100  format(a5,2f5.0,i5)                                               
      if(projec.ne.projex) go to 96                                     
      if(npro.ne.nprx)     go to 96                                         
      go to 51                                                          
 96   continue                                                          
      write(6,961) projec,npro,projex,nprx                              
 961  format(1h0,'*** stop due to error in main when reading projec...' 
     &     /7x,'input data from read(5) and read(1) are not'                
     &     ,' consistent'                                                    
     &     /7x,'from read(5);projec,npro=',a5,i5                             
     &     /7x,'from read(1);projec,npro=',a5,i5)                            
      stop                                                              
 51   continue                                                          
c     
      do 10 n=1,npro                                                     
c v1.1        read (5,200) nn,sjpr(n),papr(n),numpr(n),einpr(n)                 
        read (5,*) nn,sjpr(n),papr(n),numpr(n),einpr(n)                 
 200    format(i5,f5.0,a5,i5,f10.0)                                       
c     
        ipapr(n) = 0                                                        
        if(papr(n).eq.xplus)  ipapr(n) = 1                                  
        if(papr(n).eq.xminus) ipapr(n) =-1                                 
c                                                                       
        if(n      .ne.nn    )     go to 90                                   
        if(sjpr(n).ne.sjprx(n))   go to 90                                 
        if(papr(n).ne.paprx(n))   go to 90                                  
        if(numpr(n).ne.numprx(n)) go to 90                               
        if(dabs(einpr(n)-einprx(n)).gt.1.0d-5)  go to 90                  
        go to 10                                                           
c                                                                       
 90     continue                                                          
        write(6,900) n,sjpr(n),papr(n),numpr(n),einpr(n)                  
     &       ,nn,sjprx (n),paprx (n),numprx (n),einprx (n)         
 900    format(1h0,'*** stop due to error in reading n,sjpr(n),papr(n)    
     &       ..... '/7x,'input data from read(5) and read(1) are not'         
     &       ,' consistent'                                                    
     &       /7x,'from read(5);n,sjpr,pata,numpr,einpr='
     &       ,i5,f5.1,a5,i5,f10.2   
     &       /7x,'from read(1);n,sjpr,pata,numpr,einpr='
     &       ,i5,f5.1,a5,i5,f10.2)  
        stop                                                              
 10   continue                                                          
c                                                                       
c v1.1      read (5,100) target,amtag,ztag,ntag                               
      read (5,*) target,amtag,ztag,ntag                               
      if(target.ne.targex) go to 97                                     
      if(ntag.ne.ntax)     go to 97                                         
      go to 52                                                          
 97   continue                                                          
      write(6,962) target,targex,ntag,ntax                              
 962  format(1h0,'*** stop due to error in main when reading target...' 
     &     /7x,'input data from read(5) and read(2) are not'               
     &     ,' consistent'                                                    
     &     /7x,'from read(5);target,ntag=',a5,i5                             
     &     /7x,'from read(2);target,ntag=',a5,i5)                            
      stop                                                              
 52   continue                                                          
c                                                                       
      do 20 n=1,ntag                                                     
c v1.1        read (5,200) nn,sjta(n),pata(n),numta(n),einta(n)                 
        read (5,*) nn,sjta(n),pata(n),numta(n),einta(n)                 
        ipata(n) = 0                                                        
        if(pata(n).eq.xplus)  ipata(n) = 1                                  
        if(pata(n).eq.xminus) ipata(n) =-1                                 
c     
        if(n      .ne.nn    )     go to 91                                   
        if(sjta(n).ne.sjtax(n))   go to 91                                 
        if(pata(n).ne.patax(n))   go to 91                                  
        if(numta(n).ne.numtax(n)) go to 91                               
        if(dabs(einta(n)-eintax(n)).gt.1.0d-5)  go to 91                  
        go to 20                                                           
c                                                                       
 91     continue                                                          
        write(6,910) n,sjta(n),pata(n),numta(n),einta(n)                  
     &       ,nn,sjtax(n),patax (n),numtax (n),eintax (n)          
 910    format(1h0,'*** stop due to error in reading nx,sjta(n),pata(n)   
     &       ..... '/7x,'input data from read(5) and read(1) are not'         
     &       ,' consistent'                                                    
     &       /7x,'from read(5);n,sjta,pata,numta,einta='
     &       ,i5,f5.1,a5,i5,f10.2   
     &       /7x,'from read(2);n,sjta,pata,numta,einta='
     &       ,i5,f5.1,a5,i5,f10.2)  
        stop                                                              
 20   continue
c                                                          
c --- added for jlm ---
c v1.1      read(5,208) ee,thmin,dth,thmax,llmax
c v1.1      read(5,204) v0,alpv
c v1.1      read(5,204) w0,alpw
      read(5,*) ee,thmin,dth,thmax,llmax
      read(5,*) v0,alpv
      read(5,*) w0,alpw
      read(5,*) rc0
 204  format(3f10.0,i5)
 208  format(4f10.0,i5)
      write(6,207) ee
      write(6,205) v0,alpv
      write(6,206) w0,alpw
 207  format(f10.4,'   ee')
 205  format(3f10.4,i5,'   v0, alpv')
 206  format(3f10.4,'        w0, alpw')
c -----------------------
      read (5,300) nccmax,rrmax,drr                                     
 300  format(7x,i2, 8x,f10.0, 3x,f10.0)                                 
c                                                                       
      drr = drr                                                           
      nrrmax=rrmax/drr+1.001                                                
c                                                                       
      do 30 nc=1,nccmax                                                  
        read(5,400) ncx,levpro(nc),levtag(nc),sjcc(nc),initch(nc)         
 400    format(5x,i2,11x,i2,1x,i2,7x,f3.1,6x,i1)                          
c                                                                       
        if(ncx.eq.nc) go to 40
        write(6,920) nc,ncx                                               
 920    format(1h0,'stop due to error in reading ncc,numpro(nc)...        
     &       ----- ordering is wrong --- n ,ncc=',2i5)                         
        stop                                                              
 40     continue                                                          
c                                                                       
        np = levpro(nc)                                                     
        if(np.ge.1.and.np.le.npro) go to 45                               
        write(6,930) nc,np,npro                                           
 930    format(1h ,'*** stop due to error in reading levpro(nc)  which    
     &       should be ge.1 and le.npro, but'/2x,'nc, levpro(nc)
     &       , npro =',3i5) 
        stop                                                              
 45     continue                                                          
        nt = levtag(nc)                                                     
        if(nt.ge.1.and.nt.le.ntag) go to 46                               
        write(6,940) nc,nt,ntag                                           
 940    format(1h ,'*** stop due to error in reading levtag(nc)  which    
     &       should be ge.1 and le.ntag, but'/2x,'nc, levtag(nc)
     &       , ntag =',3i5) 
        stop                                                              
 46     continue                                                          
c                                                                       
        sjpro(nc)  = sjpr(np)                                                
        sjtag(nc)  = sjta(nt)                                                
        ipapro(nc) = ipapr(np)                                              
        ipatag(nc) = ipata(nt)                                              
        numpro(nc) = numpr(np)                                              
        numtag(nc) = numta(nt)                                              
        einall(nc) = einpr(np) + einta(nt)                                  
        iparcc(nc) = ipapro(nc)*ipatag(nc)                                  
c                                                                       
c  -----  integer,half-integer matching for (sjpro,sjtag,sjcc)          
        idsjcc = sjcc (nc)*2+0.01
        idsjpr = sjpro(nc)*2+0.01                                           
        idsjta = sjtag(nc)*2+0.01                                           
        iphase = idsjpr+idsjta-idsjcc                                       
        if(iphase/2*2.ne.iphase) go to 93                                 
c ------  triangle condition for (sjpro,sjtag,sjcc)                     
        if(idsjcc.gt.idsjpr+idsjta) go to 93                              
        if(idsjcc.lt.iabs(idsjpr-idsjta)) go to 93                        
        go to 30                                                           
 93     continue                                                          
        write(6,970) nc,sjcc(nc),np,nt,sjpro(nc),sjtag(nc)                
 970    format(1h ,'*** stop due to error in channel-spin input.'         
     &       /7x,' nc, sjcc, levpro,levtag, sjpro,sjtag ='
     &       ,i5,f5.1,3x,2i3,3x,2f5.1)
        stop                                                              
 30   continue                                                          
c  ##################
c                                                                       
      dkpr = 1.0                                                          
      dkta = 1.0                                                          
c                                                                       
      write(6,110) projec,ampro,zpro,npro                               
 110  format(1h0,a5,2f10.3,i5)                                          
      do 6 n=1,npro                                                     
        write(6,210) n,sjpr(n),papr(n),einpr(n),dkpr                      
 210    format(1h ,5x,'n=',i2,3x,'j=',f4.1,a5,3x,'e=',f8.4,3x                
     &       ,'dk=',f10.6)                                               
 6    continue                                                          
c     
      write(6,110) target,amtag,ztag,ntag                               
      do 7 n=1,ntag                                                     
        write(6,210) n,sjta(n),pata(n),einta(n),dkta                      
 7    continue                                                          
      write(6,310) nccmax,nrrmax,rrmax,drr                              
 310  format(1h0,'nccmax=',i3,3x,'nrrmax=',i4,3x,'rrmax=',f6.2,3x          
     &          ,'drr=',f6.3/)                                           
c                                                                       
      do 8 nc=1,nccmax                                                  
        write(6,410) nc,levpro(nc),levtag(nc),sjcc(nc),einall(nc)         
     &            ,initch(nc)                                           
 410    format(1h , 'nc=',i2,2i5,3x,'sj=',f4.1,3x,'ein=',f6.3
     &                                         ,3x,'init=',i2)  
 8    continue                                                          
c                                                                       
c added for ecis
      if(iecis.eq.1) goto 9111

      write(kiban,111) projec,ampro,zpro,npro                           
 111  format('proj=',a5,2f10.3,i5)                                       
c                                                                       
      do 16 n=1,npro                                                    
        write(kiban,211) n,sjpr(n),ipapr(n),einpr(n),dkpr                 
 211    format(    5x,'n=',i2,3x,'j=',f4.1,3x,'ip=',i2,3x,'e=',f8.4,3x        
     &       ,'dk=',f10.6)                                               
 16   continue                                                          
c                                                                       
      write(kiban,112) target,amtag,ztag,ntag                           
 112  format('targ=',a5,2f10.3,i5)                                       
c                                                                       
      do 17 n=1,ntag                                                    
        write(kiban,211) n,sjta(n),ipata(n),einta(n),dkta                 
 17   continue                                                          
c                                                                       
      write(kiban,113) nccmax,nrrmax,drr                                
 113  format('   nccmax=',i5,'   nrrmax=',i6,'     drr=',f10.4)           
c                                                                       
      do 18 nc=1,nccmax                                                 
        write(kiban,411) nc,levpro(nc),levtag(nc),sjcc(nc),iparcc(nc)     
     &       ,initch(nc)                                       
 411    format('nc=',i2,3x,'pr=',i2,3x,'ta=',i2,3x                           
     &       ,'j=',f5.1,3x,'ip=',i2,3x,'init=',i1,3x,'ncut=')               
 18   continue                                                          
c
c --- added for n-alp, imaginary part ---
      write(7,111) projec,ampro,zpro,npro                           
c
      do 21 n=1,npro                                                    
        write(7,211) n,sjpr(n),ipapr(n),einpr(n),dkpr                 
 21   continue                                                          
c                                                                       
      write(7,112) target,amtag,ztag,ntag                           
c                                                                       
      do 22 n=1,ntag                                                    
        write(7,211) n,sjta(n),ipata(n),einta(n),dkta                 
 22   continue                                                          
c                                                                       
      write(7,113) nccmax,nrrmax,drr                                
c                                                                       
      do 23 nc=1,nccmax                                                 
        write(7,411) nc,levpro(nc),levtag(nc),sjcc(nc),iparcc(nc)     
     &       ,initch(nc)                                       
 23   continue                                                          
c ----------------------------------------
c
 9111 continue  ! iecis=1
c                                                                       
      call   ffmake(projec,target,nrrmax,drr,nccmax                     
     &             ,sjpro,ipapro,numpro ,sjtag,ipatag,numtag            
     &             ,sjcc,levpro,levtag,kiban                            
     &             ,ce,alp,gamma                                       
     &             ,ndst,ndstx,ndg,ndtrd,ndlam,ndr,ndk
     &             ,ngapro,rgapro,amppro,ntbpro,projex
     &             ,ngatag,rgatag,amptag,ntbtag,targex
     &             ,vlam,rhopr,rhota,rhoprd,rhoprr,rhotar
     &             ,v0,alpv,w0,alpw,vlami,einta
     &             ,rgatag2,amptag2,rhotar2,iecis,vlamec,vlamiec
     &             ,comment,llmax,pata,ntag,thmin,dth,thmax
     &             ,disr,disi,divr,divi,fugou,rc0,mlam)
c                                                                       
      stop                                                              
      end                                                               
c-----------------------------------------------------------------------------
c ***   ffmake    (mutual)   ***                                        
c                                                                       
      subroutine ffmake(projec,target,nrrmax,drr ,nccmax                
     &                 ,sjpro,ipapro,numpro ,sjtag,ipatag,numtag        
     &                 ,sjcc,levpro,levtag,kiban                        
     &                 ,ce,alp,gamma
     &                 ,ndst,ndstx,ndg,ndtrd,ndlam,ndr,ndk
     &                 ,ngapro,rgapro,amppro,ntbpro,projex
     &                 ,ngatag,rgatag,amptag,ntbtag,targex
     &                 ,vlam,rhopr,rhota,rhoprd,rhoprr,rhotar
     &                 ,v0,alpv,w0,alpw,vlami,einta
     &                 ,rgatag2,amptag2,rhotar2,iecis,vlamec,vlamiec
     &                 ,comment,llmax,pata,ntag,thmin,dth,thmax
     &                 ,disr,disi,divr,divi,fugou,rc0,mlam)
c
      implicit real*8(a-h,o-z)                                          
      dimension  sjpro(ndst),ipapro(ndst),numpro(ndst)                        
      dimension  sjtag(ndst),ipatag(ndst),numtag(ndst)                        
      dimension  sjcc(ndst),levpro(ndst),levtag(ndst)                         
      dimension  vlam(ndr),vlami(ndr)
      dimension  rhopr(ndk), rhota(ndk)                               
      dimension  rhoprd(ndk)
c
      dimension rgapro(ndg,ndtrd),amppro(ndg,ndtrd)
      dimension ntbpro(ndstx,ndstx,ndlam)
c
      dimension rgatag(ndr,ndtrd),amptag(ndr,ndtrd)
      dimension ntbtag(ndstx,ndstx,ndlam)
c
      dimension rhoprr(ndk),rhotar(ndk)
      dimension disr(ndk),disi(ndk)
      dimension einta(ndstx)
c
c --- for IV calc ---
      dimension rgatag2(ndr,ndtrd),amptag2(ndr,ndtrd),rhotar2(ndk)
      dimension divr(ndk),divi(ndk)
c -------------------
c added for ecis
      dimension vlamec(ndstx,ndstx,ndlam,ndr)
      dimension vlamiec(ndstx,ndstx,ndlam,ndr)
      character*5 pata(5)
      dimension mlam(ndstx,ndstx)
c
      common /test/ factor                                              
      common /em3y/ ee                                                  
      common /protag/zpro,ztag,ampro,amtag                              
      character*5 npa(3)                                                
      character*5 projec,target
      character*5 projex,targex
c -- added for ecis
      character*70 comment

      data  npa/ ' - ','  ?',' + ' /                                    
c
c -- add for n-alp --
      pai=3.141592653589793d0
c -------------------
c
      if(nccmax.gt.ndstx)  go to 90                                        
      if(nrrmax.gt.ndr) go to 95                                        
c     
      rmax = (nrrmax-1)*drr                                               
c                                                                       
      ntb=0                                                             
c                                                                       
c  -------------------------------------------- loop of ka ---          
      do 1000 ka=1,nccmax                                               
      fi1a = sjpro(ka)                                                    
      fi2a = sjtag(ka)                                                    
      fia  = sjcc(ka)                                                     
c                                                                       
      ipa1a = ipapro(ka)                                                  
      ipa2a = ipatag(ka)                                                  
      iparia= ipa1a*ipa2a                                                
c                                                                       
      lvproa = levpro(ka)                                                 
      lvtaga = levtag(ka)                                                 
      num1a = numpro(ka)                                                  
      num2a = numtag(ka)                                                  
c  -------------------------------------------- loop of kb ---          
      do 2000 kb=1,ka                                                   
        fib   = sjcc(kb)                                                     
        lammin= dabs(fia-fib)+0.01                                         
        lammax= fia+fib+0.01                                               
c                                                                       
        ipa1bx= ipapro(kb)                                                 
        ipa2bx= ipatag(kb)                                                 
        iparib= ipa1bx*ipa2bx                                              
        if (iparia.eq.iparib) then                                        
          lmin = 0                                                       
          lmax = 4                                                       
        else                                                              
          lmin = 1                                                       
          lmax = 3                                                       
        end if                                                             
c  -------------------------------------------- loop of lam ---         
        do 3000 lam=lmin,lmax,2                                           
          if(lam.gt.lammax) go to 3000                                      
          if(lam.lt.lammin) go to 3000                                      
c                                                                       
          ntb=ntb+1                                                         
c     
c     ---- zero-setting of vlam ----                                     
          do 10 nr=1,nrrmax 
            vlam(nr) = 0.d0
c -- added for n-alp ---
            vlami(nr) = 0.d0
 10       continue 
c     ------------------------------                                     

              fi1b = sjpro(kb)          
              fi2b = sjtag(kb) 
              ipa1b = ipapro(kb) 
              ipa2b = ipatag(kb)
              lvprob= levpro(kb)
              lvtagb= levtag(kb) 
              num1b = numpro(kb) 
              num2b = numtag(kb) 
              iphase= 1 

            fnorm = iphase
c   ------------------------------------------------------------------- 
c                                                                       
c                                                                       
c                                                                       
            lam1mn = dabs(fi1a-fi1b)+0.01
            lam2mn = dabs(fi2a-fi2b)+0.01
            lam1mx = fi1a+fi1b+0.01
            lam2mx = fi2a+fi2b+0.01
c
            if (ipa1a.eq.ipa1b) then
              l1min = 0
              l1max = 4
            else
              l1min = 1
              l1max = 3
            endif
c     
            if (ipa2a.eq.ipa2b) then
              l2min = 0
              l2max = 4
            else
              l2min = 1
              l2max = 3
            endif

c  -------------------------------------------- loop of lam1 ---        
            do 4000 lam1=l1min,l1max,2 
              if(lam1.gt.lam1mx) go to 4000
              if(lam1.lt.lam1mn) go to 4000
c
              idata=1
              if(idata.eq.0) go to 4000 
c  -------------------------------------------- loop of lam2 ---        
              do 5000 lam2=l2min,l2max,2
                if(lam2.gt.lam2mx) go to 5000
                if(lam2.lt.lam2mn) go to 5000
                if( (-1.0)**(lam1+lam2-lam).lt.0.0 ) go to 96 
                if(lam.lt.iabs(lam1-lam2)) go to 5000
                if(lam.gt.lam1+lam2) go to 5000 
c
                call rhotagd(target,lvtaga,lvtagb,fi2a,fi2b,lam2,dk,kmax
     &               ,idata,rmax,gamma                        
     &                  ,ndstx,ndg,ndtrd,ndlam,ndk,ndr
     &                  ,ngatag,rgatag,amptag,ntbtag,targex,rhotar
     &                  ,drt,nrtmax,disr,disi,einta
     &                  ,divr,divi,rgatag2,amptag2,rhotar2)

c     
                if(idata.eq.0) go to 5000
                flam1 = lam1
                flam2 = lam2
                flam  = lam 
c                                                                       
c  -------------------------------------------- loop of nr ---          
c
                tpaiv=(alpv*dsqrt(pai))**(-3)
                tpaiw=(alpw*dsqrt(pai))**(-3)
c
c
                volr=0.0d0
                voli=0.0d0
                rmsr=0.0d0
                rmsi=0.0d0
                do 6000 nr =1,nrrmax
c     
                  r=drr*(nr -1) +1.0d-10
c
c --- for JLM ---
                  ffr=0.0d0
                  ffi=0.0d0
                  do 6001 irt=1,nrtmax 
                    rt=(irt-1)*drt
c -- real IS --
                    xarg=2.0d0*r*rt/alpv**2
                    ffr=ffr+rt**2*dexp(-(rt-r)**2/alpv**2)
     &                  *tpaiv*(disr(irt)*rhotar(irt)
     &                         +fugou*divr(irt)*rhotar2(irt))
     &                  *eil2(lam,xarg)*drt

c -- imag. IS --
                    xargw=2.0d0*r*rt/alpw**2
                    ffi=ffi+rt**2*dexp(-(rt-r)**2/alpw**2)
     &                  *tpaiw*(disi(irt)*rhotar(irt)
     &                         +fugou*divi(irt)*rhotar2(irt))
     &                  *eil2(lam,xargw)*drt
 6001             continue
c -----------------
c
                  if(idata.eq.0) go to 5000
                  vlam(nr)=ffr*dsqrt(4.0d0*pai)*v0
                  vlami(nr)=ffi*dsqrt(4.0d0*pai)*w0
                  volr=volr+vlam(nr)*r**2*drr
                  voli=voli+vlami(nr)*r**2*drr
                  rmsr=rmsr+vlam(nr)*r**4*drr
                  rmsi=rmsi+vlami(nr)*r**4*drr
 6000           continue

 6005         format(f10.3,1p4d12.4)
 5000         continue
 4000       continue
c          write(6,300) (vlam(nr),nr=1,nrrmax)                               
c 300      format(1h ,6f11.4)                                                
c                                                                       
c added for ecis
          do nr=1,nrrmax
            vlamec(ka,kb,lam+1,nr)=vlam(nr)
            vlamiec(ka,kb,lam+1,nr)=vlami(nr)
          enddo

          if(iecis.eq.1) goto 9111

          icomme = 2                                                          
          write(kiban,210) ntb,ka,kb,lam,icomme                             
     &         ,fi1a,npa(ipa1a+2),num1a ,fi2a,npa(ipa2a+2),num2a       
     &         ,fia,lvproa,lvtaga                                      
     &         ,fi2b,npa(ipa2b+2),num2b ,fi1b,npa(ipa1b+2),num1b       
     &         ,fib,lvtagb,lvprob                                      
 210      format('ntb=',i4,'  ka=',i2,'  kb=',i2,'  lam=',i1,'  c=',i1
     &         /33x,2( '(',f4.1,a3,i2,')' ),' : ia=',f3.1,1x,2i3          
     &         /33x,2( '(',f4.1,a3,i2,')' ),' : ia=',f3.1,1x,2i3)         
c                                                                       
          write(kiban,310) (vlam(nr),nr=1,nrrmax)                           
 310      format(1p6d12.5)                                                  
c
c --- added for n-alp ---
          write(7,210) ntb,ka,kb,lam,icomme
     &         ,fi1a,npa(ipa1a+2),num1a ,fi2a,npa(ipa2a+2),num2a
     &         ,fia,lvproa,lvtaga
     &         ,fi2b,npa(ipa2b+2),num2b ,fi1b,npa(ipa1b+2),num1b
     &         ,fib,lvtagb,lvprob
          write(7,310) (vlami(nr),nr=1,nrrmax)
c -----------------------

 9111 continue   ! iecis=1
c                                                                       
 3000   continue   ! lam-loop
 2000 continue     ! kb-loop
 1000 continue     ! ka-loop

c added for ecis
      call output(lmax,vlamec,vlamiec,
     &            ndst,ndstx,ndr,ndlam,
     &            comment,ntag,llmax,nccmax,dble(nrrmax-1)*drr,drr,
     &            sjpro,sjtag,pata,einta,thmin,dth,thmax,rc0,mlam)
c                                                                       
      return                                                            
c                                                                       
 90   continue                                                          
      write(6,900) nccmax                                               
 900  format(1h0,'stop. error in ffmake.nccmax > ndstx. ---  nccmax='
     & ,i3) 
      stop                                                              
 95   continue                                                          
      write(6,950) nrrmax                                               
 950  format(1h0,'stop. error in ffmake.nrrmax > ndr.--- nrrmax=',i4)
      stop                                                              
 96   continue                                                          
      write(6,960) ka,kb,lam1,lam2,lam                                  
 960  format(1h0,'stop.error in ffmake.--- combination is invalid. --',
     &     'ka,kb,lam1,lam2.lam=',5i5)                                        
      stop                                                              
      end                                                               
c
c----------------------------------------------------------------------------
c  ***  rhotagd ***                                                      
      subroutine  rhotagd(anucl,lva,lvb,fia,fib,lam,dk,kmax
     &                   ,idata,rmax,gamma                              
     &                   ,ndstx,ndg,ndtrd,ndlam,ndk,ndr
     &                   ,ngatag,rgatag,amptag,ntbtag,targex,rhotar
     &                   ,drt,nrtmax,disr,disi,einta
     &                   ,divr,divi,rgatag2,amptag2,rhotar2)
c                                                                       
c    -----  transition densities of target                              
c
      implicit real*8(a-h,o-z)                                          
      character*5 targex,anucl
c
      dimension rgatag(ndr,ndtrd),amptag(ndr,ndtrd)
      dimension ntbtag(ndstx,ndstx,ndlam)
c
c      dimension  rhotad(ndk),rhotar(ndk)                              
      dimension  rhotar(ndk)                              
      dimension disr(ndk),disi(ndk)
      dimension einta(ndstx)
c --- for IV calc. ---
      dimension rgatag2(ndr,ndtrd),amptag2(ndr,ndtrd),rhotar2(ndk)
      dimension divr(ndk),divi(ndk)
c --------------------
c
      common /em3y/ ee                                                  
      common /switch/idens
c
      common /protag/zpro,ztag,ampro,amtag                              
      parameter (hc=197.3269602d0,alf=137.03599976d0)

c --- JLM parameter ---
      dimension a(3,3),b(3,3),c(3,3),d(4,4),f(4,4)
      data ( (a(i,j),j=1,3),i=1,3 )
     & / -0.9740E+03,   0.1126E+02,  -0.4250E-01,
     &    0.7097E+04,  -0.1257E+03,   0.5853E+00,
     &   -0.1953E+05,   0.4180E+03,  -0.2054E+01 /
c
      data ( (b(i,j),j=1,3),i=1,3 )
     & /  0.3601E+03,  -0.5224E+01,   0.2051E-01,
     &   -0.2691E+04,   0.5130E+02,  -0.2470E+00,
     &    0.7733E+04,  -0.1717E+03,   0.8846E+00 /
c
      data ( (c(i,j),j=1,3),i=1,3 )
     & /  0.4557E+01,  -0.5291E-02,   0.6108E-05,
     &   -0.2051E+01,  -0.4906E+00,   0.1812E-02,
     &   -0.6509E+02,   0.3095E+01,  -0.1190E-01 /
c
      data ( (d(i,j),j=1,4),i=1,4 )
     & / -0.1483E+04,   0.3718E+02,  -0.3549E+00,   0.1119E-02,
     &    0.2988E+05,  -0.9318E+03,   0.9591E+01,  -0.3160E-01,
     &   -0.2128E+06,   0.7209E+04,  -0.7752E+02,   0.2611E+00,
     &    0.5125E+06,  -0.1796E+05,   0.1980E+03,  -0.6753E+00 /
c
      data ( (f(i,j),j=1,4),i=1,4 )
     & /  0.5461E+03,  -0.1120E+02,   0.1065E+00,  -0.3541E-03,
     &   -0.8471E+04,   0.2300E+03,  -0.2439E+01,   0.8544E-02,
     &    0.5172E+05,  -0.1520E+04,   0.1717E+02,  -0.6211E-01,
     &   -0.1140E+06,   0.3543E+04,  -0.4169E+02,   0.1537E+00 /
c -----------------------
c
c      data  memo/0/                                                     
c
      pai = 3.1415926d0                                                   
      if(anucl.ne.targex) go to 95                                      
c                                                                       
      spai  = dsqrt(pai)                                                 
      sq4pai= dsqrt(4.0*pai)                                             
      sq2   = dsqrt(2.0d0)                                               
c

      idata = 1                                                           
c                                                                       
      no = ntbtag(lva,lvb,lam+1)                                       
c                                                                       
      noa = ntbtag(lva,lva,1)                                            
      nob = ntbtag(lvb,lvb,1)                                            
c                                                                       
      factor = 1.0                                                        
      if(no.ne.-999) go to 1                                            
c                                                                       
      nox = ntbtag(lvb,lva  ,lam+1)                                       
      if(nox.eq.-999) go to 90                                          
      no  = nox                                                            
      factor = (-1.0)**lam *dsqrt( (2*fib+1)/(2*fia+1) )                  
 1    continue                                                          
c      dr = 0.03                                                           
      dr=0.02d0
      nrmax = rmax/dr+1.001                                               
c -- for JLM --
      drt=dr
      nrtmax = nrmax
      rc=1.25d0*amtag**(1.0d0/3.0d0)   ! for JLM calc.
c ---------------
c --- check ---
      write(6,*) no,noa,nob
c      do 99 ir=1,ngatag
c        write(6,98) rgatag(ir,no),amptag(ir,no)
c     &                           ,amptag(ir,noa),amptag(ir,nob)
c   99 continue
c   98 format(f8.3,1p3d12.4)
c -------------
c
c -- correction of phase ---
      iphase = idnint(fib-fia)+lam
      iphase = iphase/2
      write(6,*) 'iphase=',iphase
c --------------------------

      do 1001 nr=1,nrmax                                                
        x=(nr-1)*dr                                                       
        if(x.eq.0.0) x=1.0d-20                                            
        s  = 0.0                                                             
        sa = 0.0                                                            
        sb = 0.0                                                            
        s2  = 0.0                                                             
        sa2 = 0.0                                                            
        sb2 = 0.0                                                            
c
c --- Coulomb pot. for evaluation of the energy ---
      if(x.le.rc) then
        vcoul=zpro*ztag/2.0d0/rc/alf*hc*(3.0d0-(x/rc)**2)
      else
        vcoul=zpro*ztag/x/alf*hc
      end if
      eeav=( einta(lva)+einta(lvb) )/2.0d0
      eeff=ee-vcoul-eeav
c      write(6,*) x,eeff,vcoul,eeav
      if(eeff.lt.0.0) stop'E in JLM is less than 0'
c -------------------------------------------------
c
c --- for idens=0 ---
        if(idens.eq.0) then
          do 9 n=1,ngatag                                                   
c - for proton -
            rg = rgatag(n, no)                                                 
            rga= rgatag(n, noa)                                                
            rgb= rgatag(n, nob)                                                
            s = s +amptag(n, no) *x**lam *dexp(-(x/rg )**2)                   
            sa= sa+amptag(n,noa)         *dexp(-(x/rga)**2) /sq4pai           
            sb= sb+amptag(n,nob)         *dexp(-(x/rgb)**2) /sq4pai           
c - for neutron -
            rg2 = rgatag2(n, no)
            rga2= rgatag2(n, noa)
            rgb2= rgatag2(n, nob)
            s2 =s2 +amptag2(n, no) *x**lam *dexp(-(x/rg2 )**2)
            sa2=sa2+amptag2(n,noa)         *dexp(-(x/rga2)**2)/sq4pai
            sb2=sb2+amptag2(n,nob)         *dexp(-(x/rgb2)**2)/sq4pai
c
 9        continue                                                          
c        write(6,1002) x,s,sa,sb,s2,sa2,sb2
c --- for idens=1 ---
c modified        else if(idens.eq.1) then
        else if(idens.eq.1.or.idens.eq.-1) then
          irmax=ngatag
c - for proton -
          s =suphodtd2a(x,rgatag,amptag,no, irmax,ndr,ndtrd)
          sa=suphodtd2a(x,rgatag,amptag,noa,irmax,ndr,ndtrd)/sq4pai
          sb=suphodtd2a(x,rgatag,amptag,nob,irmax,ndr,ndtrd)/sq4pai
c - for neutron -
          s2 =suphodtd2a(x,rgatag2,amptag2,no, irmax,ndr,ndtrd)
          sa2=suphodtd2a(x,rgatag2,amptag2,noa,irmax,ndr,ndtrd)/sq4pai
          sb2=suphodtd2a(x,rgatag2,amptag2,nob,irmax,ndr,ndtrd)/sq4pai
c        write(6,1002) x,s,sa,sb,s2,sa2,sb2
        end if
c -------------------
        rhotar(nr)=(s+s2)*(-1.0d0)**iphase
        rhotar2(nr)=(s2-s)*(-1.0d0)**iphase
        rhotad=(dabs(sa+sb+sa2+sb2)/2.0d0)
c
c -- RIS --
        disr(nr)= a(1,1)+a(1,2)*eeff+a(1,3)*eeff**2
     &         +( a(2,1)+a(2,2)*eeff+a(2,3)*eeff**2 )*rhotad
     &         +( a(3,1)+a(3,2)*eeff+a(3,3)*eeff**2 )*rhotad**2
c
c -- IIS --
        disi(nr)= d(1,1)+d(1,2)*eeff+d(1,3)*eeff**2+d(1,4)*eeff**3
     &         +( d(2,1)+d(2,2)*eeff+d(2,3)*eeff**2+d(2,4)*eeff**3)
     &  *rhotad
     &         +( d(3,1)+d(3,2)*eeff+d(3,3)*eeff**2+d(3,4)*eeff**3)
     &  *rhotad**2
     &         +( d(4,1)+d(4,2)*eeff+d(4,3)*eeff**2+d(4,4)*eeff**3)
     &  *rhotad**3
        fermie=rhotad*(-510.8d0+3222.0d0*rhotad-6250.0d0*rhotad**2)
        facisi=( 1.0d0+600.0d0/(eeff-fermie)**2 )
        disi(nr)=disi(nr)/facisi
c
c --- IV part --

c -- RIV --
        facriv1=( c(1,1)+c(1,2)*eeff+c(1,3)*eeff**2 )*rhotad
     &         +( c(2,1)+c(2,2)*eeff+c(2,3)*eeff**2 )*rhotad**2
     &         +( c(3,1)+c(3,2)*eeff+c(3,3)*eeff**2 )*rhotad**3
c
        facriv2 = b(1,1)+b(1,2)*eeff+b(1,3)*eeff**2
     &         +( b(2,1)+b(2,2)*eeff+b(2,3)*eeff**2 )*rhotad
     &         +( b(3,1)+b(3,2)*eeff+b(3,3)*eeff**2 )*rhotad**2
c
        divr(nr)=(1.0d0-facriv1)*facriv2  !*rhotad2/rhotad
c
c -- IIV --
        divi(nr)= f(1,1)+f(1,2)*eeff+f(1,3)*eeff**2+f(1,4)*eeff**3
     &         +( f(2,1)+f(2,2)*eeff+f(2,3)*eeff**2+f(2,4)*eeff**3)
     &  *rhotad
     &         +( f(3,1)+f(3,2)*eeff+f(3,3)*eeff**2+f(3,4)*eeff**3)
     &  *rhotad**2
     &         +( f(4,1)+f(4,2)*eeff+f(4,3)*eeff**2+f(4,4)*eeff**3)
     &  *rhotad**3
c
        faciiv1=( a(1,2)+2.0d0*a(1,3)*eeff )*rhotad
     &         +( a(2,2)+2.0d0*a(2,3)*eeff )*rhotad**2
     &         +( a(3,2)+2.0d0*a(3,3)*eeff )*rhotad**3
c
        faciiv2=1.0d0+1.0d0/(eeff-fermie)
c
        divi(nr)=(1.0d0-facriv1)/(1.0d0-faciiv1)/faciiv2*divi(nr)

c for check
c        write(6,1002) x,rhotad,disr(nr),disi(nr),fermie
 1001 continue                                                          
 1002 format(f8.3,1p6d12.4)
c  --------------------------------                                     
c                                                                       
      return                                                            
c                                                                       
 90   continue                                                          
      idata = 0                                                           

      return                                                            
c                                                                       
 95   continue                                                          
      write(6,950) anucl,targex                                         
 950  format(1h0,' --- stop in rhotag. you request',a5,'  ,but this'    
     &       ,' function is for',a5,'  ---' )                           
      stop                                                              
      end                                                               
c-----------------------------------------------------------------------------
c  *** denpro ***
c    -----  transition densities of projectile                          
      subroutine  denpro(ndstx,ndg,ndtrd,ndlam
     &   ,nprx,ngapro,sjprx,numprx,einprx,rgapro,amppro,ntbpro
     &   ,projex,paprx,ipn)
c
      implicit real*8(a-h,o-z)                                          
      character*5 projex,paprx                                                 
c
      dimension sjprx(ndstx),numprx(ndstx),einprx(ndstx) 
      dimension rgapro(ndg,ndtrd),amppro(ndg,ndtrd)
      dimension ntbpro(ndstx,ndstx,ndlam)
      dimension paprx(ndstx)
c
c -- added --
c v1.1      if(ipn.eq.1) projex='   h1'
c v1.1      if(ipn.eq.0) projex='    n'
      if(ipn.eq.1) projex='h1'
      if(ipn.eq.0) projex='n'
      nprx=1
      ngapro=0
      sjprx(1)=0
c v1.1      paprx(1)='    +'
      paprx(1)='+'
      numprx(1)=1
      einprx(1)=0.0d0
c 
      do 15 ka=1,ndstx
      do 15 kb=1,ndstx
      do 15 lam1=1,ndlam
        ntbpro(ka,kb,lam1) = -999                                          
 15   continue                                                         
c
      ntbpro(1,1,1)=1
c dummy
      rgapro(1,1)=1.0d0
      amppro(1,1)=0.0d0
c
 90   return                                                            
      end                                                               
c---------------------------------------------------------------------------
c   *** dentag ***
c    -----  transition densities of target - proton                             
      subroutine  dentag(ndstx,ndg,ndtrd,ndlam
     &   ,ntax,ngatag,sjtax,numtax,eintax,rgatag,amptag,ntbtag
     &   ,targex,patax,ndr,mlam)
c
      implicit real*8(a-h,o-z)                                          
      character*5 targex,patax                                                 
c
      dimension sjtax(ndstx),numtax(ndstx),eintax(ndstx) 
c      dimension rgatag(ndg,ndtrd),amptag(ndg,ndtrd)
      dimension rgatag(ndr,ndtrd),amptag(ndr,ndtrd)
      dimension ntbtag(ndstx,ndstx,ndlam)        
      dimension patax(ndstx)
      dimension mlam(ndstx,ndstx)
      common /switch/idens
c
      kiban=2
c
        read(kiban,500) targex,ntax,ngatag,dr
  500   format(a5,9x,i2,10x,i4,5x,f8.0)
c                                                                       
        do 10 n=1,ntax                                                     
c v1.1          read(kiban,510)  nx,sjtax(n),patax(n),numtax(n),eintax(n) 
          read(kiban,*)  nx,sjtax(n),patax(n),numtax(n),eintax(n) 
 510      format(i5,f5.1,a5,i5,f10.2)                                       
          if(n.eq.nx) go to 10                                               
          write(6,955) n,nx                                                 
 955      format(1h0,'error in dentag when reading nx,sjtax(n).....'        
     &         ,'stop due to n.ne.nx --- n, nx=',2i5)                      
          stop                                                              
 10     continue                                                          
c                                                                       
        do 15 ka=1,ndstx
        do 15 kb=1,ndstx
        do 15 lam1=1,ndlam
          ntbtag(ka,kb,lam1)=-999                                          
 15     continue                                                         
c
c -- input by Gauss ---
      if(idens.eq.0) then
c
        do 25 nox=1,1000                                                  
          read(kiban,520,end=90) no,ka,kb,lam ,anorm                        
          mlam(ka,kb)=lam
 520      format(3x,i4,8x,i2,6x,i2,7x,i2,10x,f10.0)                         
c     -------  input f.f. normalization to fit the electron f.f. data.      
          if(anorm.eq.0.0) anorm=1.0                                        
          ntbtag(ka,kb,lam+1)=no                                            
          read(kiban,521) dummy                                             
 521      format(f5.0)                                                      
          read(kiban,530) (rgatag(i,no),i=1,ngatag)                         
 530      format(4d18.10)                                                   
          read(kiban,521)                                                   
          read(kiban,540) (amptag(i,no),i=1,ngatag)                         
 540      format(4d18.10)                                                   
          do 20 i=1,ngatag                                                   
            amptag(i,no)=amptag(i,no)*anorm                                   
 20       continue                                                          
 25     continue                                                          
c
c -- numerical input --
      else if(idens.eq.1) then
        do nox=1,1000                                                  
          read(kiban,542,end=90) no,ka,kb,lam,anorm
          mlam(ka,kb)=lam
          if(anorm.eq.0.0) anorm=1.0
          ntbtag(ka,kb,lam+1)=no                                            
          irmax=ngatag
          do i=1,irmax
            read(kiban,541) amptag(i,no)
            rgatag(i,no)=dble(i-1)*dr
            amptag(i,no)=amptag(i,no)*anorm
          enddo
        enddo
 542    format(3x,i4,8x,i2,6x,i2,7x,i2,10x,f10.0)
 541    format(d12.4)                                                   
c
c -- numerical input -- (free format)
      else if(idens.eq.-1) then
        do nox=1,1000 
          read(kiban,542,end=90) no,ka,kb,lam,anorm
          mlam(ka,kb)=lam
          if(anorm.eq.0.0) anorm=1.0 
          ntbtag(ka,kb,lam+1)=no
          irmax=ngatag
          do i=1,irmax
            read(kiban,*) rgatag(i,no),amptag(i,no)
            amptag(i,no)=amptag(i,no)*anorm
          enddo
        enddo

c -- input error --
      else
        write(6,*) 'idens=',idens
        write(6,*) 'no such number for idens'
        stop
      end if
c
 90   return                                                            
      end                                                               
c
c   *** dentag2 ***
c    -----  transition densities of target - neutron                            
      subroutine  dentag2(ndstx,ndg,ndtrd,ndlam
     &   ,ntax,ngatag,sjtax,numtax,eintax,rgatag2,amptag2,ntbtag
     &   ,targex,patax,ndr,mlam)
c
      implicit real*8(a-h,o-z)                                          
      character*5 targex,patax                                                 
c
      dimension sjtax(ndstx),numtax(ndstx),eintax(ndstx) 
      dimension rgatag2(ndr,ndtrd),amptag2(ndr,ndtrd)
      dimension ntbtag(ndstx,ndstx,ndlam)        
      dimension patax(ndstx)
      dimension mlam(ndstx,ndstx)
      common /switch/idens
c
      kiban=4
c
        read(kiban,500) targex,ntax,ngatag,dr
  500   format(a5,9x,i2,10x,i4,5x,f8.0)
c                                                                       
        do 10 n=1,ntax                                                     
c v1.1          read(kiban,510)  nx,sjtax(n),patax(n),numtax(n),eintax(n)
          read(kiban,*)  nx,sjtax(n),patax(n),numtax(n),eintax(n)
 510      format(i5,f5.1,a5,i5,f10.2)                                       
          if(n.eq.nx) go to 10                                               
          write(6,955) n,nx                                                 
 955      format(1h0,'error in dentag when reading nx,sjtax(n).....'        
     &         ,'stop due to n.ne.nx --- n, nx=',2i5)                      
          stop                                                              
 10     continue                                                          
c                                                                       
        do 15 ka=1,ndstx
        do 15 kb=1,ndstx
        do 15 lam1=1,ndlam
          ntbtag(ka,kb,lam1)=-999                                          
 15     continue                                                         
c
c -- input by Gauss ---
      if(idens.eq.0) then
c
        do 25 nox=1,1000                                                  
          read(kiban,520,end=90) no,ka,kb,lam ,anorm                        
          mlam(ka,kb)=lam
 520      format(3x,i4,8x,i2,6x,i2,7x,i2,10x,f10.0)                         
c     -------  input f.f. normalization to fit the electron f.f. data.      
          if(anorm.eq.0.0) anorm=1.0                                        
          ntbtag(ka,kb,lam+1)=no                                            
          read(kiban,521) dummy                                             
 521      format(f5.0)                                                      
          read(kiban,530) (rgatag2(i,no),i=1,ngatag)                         
 530      format(4d18.10)                                                   
          read(kiban,521)                                                   
          read(kiban,540) (amptag2(i,no),i=1,ngatag)                         
 540      format(4d18.10)                                                   
          do 20 i=1,ngatag                                                   
            amptag2(i,no)=amptag2(i,no)*anorm                                   
 20       continue                                                          
 25     continue                                                          
c
c -- numerical input --
      else if(idens.eq.1) then
        do nox=1,1000                                                  
          read(kiban,542,end=90) no,ka,kb,lam,anorm
          mlam(ka,kb)=lam
          if(anorm.eq.0.0) anorm=1.0
          ntbtag(ka,kb,lam+1)=no                                            
          irmax=ngatag
          do i=1,irmax
            read(kiban,541) amptag2(i,no)
            rgatag2(i,no)=dble(i-1)*dr
            amptag2(i,no)=amptag2(i,no)*anorm
          enddo
        enddo
 542    format(3x,i4,8x,i2,6x,i2,7x,i2,10x,f10.0)
 541    format(d12.4)                                                   

c -- numerical input -- (free format)
      else if(idens.eq.-1) then
        do nox=1,1000
          read(kiban,542,end=90) no,ka,kb,lam,anorm
          mlam(ka,kb)=lam
          if(anorm.eq.0.0) anorm=1.0
          ntbtag(ka,kb,lam+1)=no
          irmax=ngatag
          do i=1,irmax
            read(kiban,*) rgatag2(i,no),amptag2(i,no)
            amptag2(i,no)=amptag2(i,no)*anorm
          enddo
        enddo
c
c -- input error --
      else
        write(6,*) 'idens=',idens
        write(6,*) 'no such number for idens'
        stop
      end if
c
 90   return                                                            
      end                                                               
c
c ----------------------------------------------------------------
c *** exp(-x)*I(x) *** made by S.Takagi, modified by Takashina
	double precision function eil2(l,x)
	implicit double precision (a-h,o-z)
	parameter (xs0=1.1d-2)
c
        if(dabs(x).lt.1.0d-4) then
          if(l.eq.0) eil2=1.0d0
          if(l.ne.0) eil2=0.0d0
          return
        end if
c
	xs=xs0*l**2.28d0
	if(x.lt.xs) eil2=eilb(l,x)
	if(x.ge.xs) eil2=eilf(l,x)
c
        return
	end
c
	double precision function eilb(l,x)
c
c	Be careful if x is more than 40.
c       backward recurrence formula
c
	implicit double precision (a-h,o-z)
	dimension solution(0:300)
	parameter(pi=3.141592653589793238d0)
c
c
	if(x.lt.0.d0)stop
     &' x < 0 is not available'
	plus2=0.d0
	plus1=1.0d-25
c
	if(l.eq.0)then
	eilb=(1.d0-dexp(-2.d0*x))/(2.d0*x)
	goto 50
	else if(l.eq.1)then
	eilb=((1.d0-1.d0/x)+(1.d0+1.d0/x)*dexp(-2.d0*x))/(2.d0*x)
	goto 50
	endif
c
	do 11 i=0,l
	lx=l-i
c
	solution(lx)=(2.d0*lx+3.d0)*plus1/x+plus2
c
	plus2=plus1	
	plus1=solution(lx)
c	
11 	continue
c
c	normalization using i0(x)=sinh(x)/x
c
	unit=(1.d0-dexp(-2.d0*x))/(2.d0*x)
c
      constant=solution(0)/unit
	eilb=solution(l)/constant
50	continue
c
        return
	end

c
c	forward recurrence formula
c
      double precision function eilf(l,x)
      implicit double precision (a-h,o-z)
c
       if(x.le.0.d0)stop
     &'Error in subroutine eilf: x > 0 not satisfied'
c
	b0=(1.d0-dexp(-2.d0*x))/(2.d0*x)
      eilf=b0
       if(l.ge.1)then
	 b1=((1.d0-1.d0/x)+(1.d0+1.d0/x)*dexp(-2.d0*x))/(2.d0*x)
       eilf=b1
         if(l.ge.2)then
       do 10 i=1,l-1
        eilf=-(2*i+1)/x*b1+b0
        b0=b1
        b1=eilf
  10   continue
         endif
        endif
c
      return
      end
c
*process nosource
c ***  suphodtd2a   (real*8) for two dimension of y
c                  i,j are inversed
c      the value of outside is zero
c    this program is o.k. only when jisu=3.    ------ care ----
c    this program is o.k. only when dx=const   ------ care ----
c
c
      function  suphodtd2a(xin,x,y,i,nrmax,nrdim,idim)
      implicit real*8(a-h,o-z)
      dimension  x(nrdim,idim),y(nrdim,idim)
c
      jisu=3
      izisu=jisu+1
c
c
      if(nrmax.ge.izisu) go to 4000
      write(6,400) nrmax,jisu
  400 format(1h0,' nrmax,jisu=',2i5,10x,'stop in suphodtd2a')
      stop
 4000 continue
c
      nnr=(xin-x(1,i))/(x(2,i)-x(1,i))+1
c
c      write(6,*) xin,x(i,1),x(i,2)-x(i,1),nnr,nrmax
      if(nnr.ge.1.and.nnr.le.nrmax) go to 5000
c      write(6,500) nnr
c  500 format(1h0,' nnr=',i5,10x,'stop in hokan --- xin < x(i,1) ---'
c     1        ,1x,' or  --- xin > x(i,nrmax) ---')
c      stop
       suphodtd2a=0.0d0
       return
 5000 continue
c
      jmin=nnr-2
      jmax=nnr+1
      if(jmin.le.1) jmin=1
      if(jmax.ge.nrmax) jmin=nrmax-3
c
c
      x0=x(jmin,i)
      x1=x(jmin+1,i)
      x2=x(jmin+2,i)
      x3=x(jmin+3,i)
c
      y0=y(jmin,i)
      y1=y(jmin+1,i)
      y2=y(jmin+2,i)
      y3=y(jmin+3,i)
c
      xin0=xin-x0
      xin1=xin-x1
      xin2=xin-x2
      xin3=xin-x3
c
      x01=x0-x1
      x02=x0-x2
      x03=x0-x3
c
      x10=x1-x0
      x12=x1-x2
      x13=x1-x3
c
      x20=x2-x0
      x21=x2-x1
      x23=x2-x3
c
      x30=x3-x0
      x31=x3-x1
      x32=x3-x2
c
      xx0=xin1/x01
     1   *xin2/x02
     2   *xin3/x03
c
      xx1=xin0/x10
     1   *xin2/x12
     2   *xin3/x13
c
      xx2=xin0/x20
     1   *xin1/x21
     2   *xin3/x23
c
      xx3=xin0/x30
     1   *xin1/x31
     2   *xin2/x32
c
      suphodtd2a=xx0*y0
     1      +xx1*y1
     2      +xx2*y2
     3      +xx3*y3
c
      return
      end 

c output file is unit=3

      subroutine output(lmax,vlamec,vlamiec,
     &                  ndst,ndstx,ndr,ndlam,
     &                  comment,ntag,llmax,nccmax,rrmax,drr,
     &                  sjpro,sjtag,pata,einta,thmin,dth,thmax,rc0,mlam)

      implicit double precision (a-h,o-z)
      character*70 comment
      character*5 pata
      character*1 pata1
      dimension vlamec(ndstx,ndstx,ndlam,ndr)
      dimension vlamiec(ndstx,ndstx,ndlam,ndr)
      dimension sjpro(ndst),sjtag(ndst),pata(ndstx),einta(ndstx)
      dimension mlam(ndstx,ndstx)

      common /protag/zpro,ztag,ampro,amtag
      common /em3y/ ee

      pai=3.141592653589793d0

      nrrmax=idnint(rrmax/drr)+1
c      factor=dsqrt(4.0d0*pai)
c      factor=dsqrt(5.0d0)  ! lam or I_f ? docchi?
      factor=dsqrt(2.0d0*dble(mlam(2,1))+1.0d0)
      write(6,*) 'h2e,factor=',factor

      write(3,10) comment
   10 format(a70)
      write(3,11)
   11 format('FFFFFFTFFFFTFFFFFFFFFFFFTFFFFFFFFFFFFFFFFFFFFFFFFF'/
     &       'TTTTTFFTFFFFFFFFFTFFTFFTFFFFFFFFFFFFFFFFFFFFFFFFFF')
      write(3,12) ntag,llmax
   12 format(5i5)
      write(3,13) drr,rrmax
   13 format(5f10.3)
      pata1=pata(1)
      write(3,14) sjtag(1),pata1,ee,sjpro(1),ampro,amtag,zpro*ztag
      pata1=pata(2)
      write(3,14) sjtag(2),pata1,einta(2)
   14 format(f5.2,4x,a1,5f10.3)
      write(3,13) thmin,dth,thmax
      write(3,12) 1,1,0
      write(3,12) 1,2,1
      write(3,15) 1,mlam(2,1),0,0,-1.00
      write(3,12) 2,2,0
   15 format(4i5,f10.2)

      write(3,16) 1,1,0,1  !  real central elastic
      write(3,17) 1.0,1.0
      write(3,18) (dble(ir-1)*drr,-vlamec(1,1,1,ir),ir=2,nrrmax-2)
      write(3,19) (dble(ir-1)*drr,-vlamec(1,1,1,ir),ir=nrrmax-1,nrrmax)

      write(3,16) 1,1,0,2  ! imag. central elastic
      write(3,17) 1.0,1.0
      write(3,18) (dble(ir-1)*drr,-vlamiec(1,1,1,ir),ir=2,nrrmax-2)
      write(3,19) (dble(ir-1)*drr,-vlamiec(1,1,1,ir),ir=nrrmax-1,nrrmax)

      write(3,16) 1,1,0,3,0,2,0,-1  ! real surface elastic
      write(3,*) 
      write(3,16) 1,1,0,4,0,2,0,-1  ! imag surface elastic
      write(3,*) 
      write(3,16) 1,1,0,7,0,2,0,-1  ! Coulomb
      write(3,17) zpro*ztag,rc0*amtag**(1.0d0/3.0d0)

      write(3,16) 1,2,1,1  ! real central coupling
      write(3,17) 1.0,1.0
      write(3,18) (dble(ir-1)*drr,vlamec(2,1,mlam(2,1)+1,ir)*factor
     &                                              ,ir=2,nrrmax-2)
      write(3,19) (dble(ir-1)*drr,vlamec(2,1,mlam(2,1)+1,ir)*factor
     &                                              ,ir=nrrmax-1,nrrmax)

      write(3,16) 1,2,1,2  ! imag central coupling
      write(3,17) 1.0,1.0
      write(3,18) (dble(ir-1)*drr,vlamiec(2,1,mlam(2,1)+1,ir)*factor
     &                                                  ,ir=2,nrrmax-2)
      write(3,19) (dble(ir-1)*drr,vlamiec(2,1,mlam(2,1)+1,ir)*factor
     &                                             ,ir=nrrmax-1,nrrmax)

      write(3,16) 1,2,1,3,0,0,0,-2  ! real surface coupling
      write(3,*) 
      write(3,16) 1,2,1,4,0,0,0,-2  ! imag surface coupling
      write(3,*) 
      write(3,20) 

   16 format(8i5)
   17 format(2f10.5)
   18 format(f6.2,6x,f15.8,3x,f6.2,6x,f15.8)
   19 format(f6.2,6x,f15.8,3x,f6.2,6x,f15.8,'   LAST')
   20 format('FIN')

      return
      end
